//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class CustomTorsionForce : Force {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal CustomTorsionForce(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.CustomTorsionForce_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(CustomTorsionForce obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~CustomTorsionForce() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_CustomTorsionForce(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public CustomTorsionForce(string energy) : this(OpenMMSwigPINVOKE.new_CustomTorsionForce(energy), true) {
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int getNumTorsions() {
    int ret = OpenMMSwigPINVOKE.CustomTorsionForce_getNumTorsions(swigCPtr);
    return ret;
  }

  public int getNumPerTorsionParameters() {
    int ret = OpenMMSwigPINVOKE.CustomTorsionForce_getNumPerTorsionParameters(swigCPtr);
    return ret;
  }

  public int getNumGlobalParameters() {
    int ret = OpenMMSwigPINVOKE.CustomTorsionForce_getNumGlobalParameters(swigCPtr);
    return ret;
  }

  public int getNumEnergyParameterDerivatives() {
    int ret = OpenMMSwigPINVOKE.CustomTorsionForce_getNumEnergyParameterDerivatives(swigCPtr);
    return ret;
  }

  public string getEnergyFunction() {
    string ret = OpenMMSwigPINVOKE.CustomTorsionForce_getEnergyFunction(swigCPtr);
    return ret;
  }

  public void setEnergyFunction(string energy) {
    OpenMMSwigPINVOKE.CustomTorsionForce_setEnergyFunction(swigCPtr, energy);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int addPerTorsionParameter(string name) {
    int ret = OpenMMSwigPINVOKE.CustomTorsionForce_addPerTorsionParameter(swigCPtr, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public string getPerTorsionParameterName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomTorsionForce_getPerTorsionParameterName(swigCPtr, index);
    return ret;
  }

  public void setPerTorsionParameterName(int index, string name) {
    OpenMMSwigPINVOKE.CustomTorsionForce_setPerTorsionParameterName(swigCPtr, index, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public int addGlobalParameter(string name, double defaultValue) {
    int ret = OpenMMSwigPINVOKE.CustomTorsionForce_addGlobalParameter(swigCPtr, name, defaultValue);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public string getGlobalParameterName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomTorsionForce_getGlobalParameterName(swigCPtr, index);
    return ret;
  }

  public void setGlobalParameterName(int index, string name) {
    OpenMMSwigPINVOKE.CustomTorsionForce_setGlobalParameterName(swigCPtr, index, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public double getGlobalParameterDefaultValue(int index) {
    double ret = OpenMMSwigPINVOKE.CustomTorsionForce_getGlobalParameterDefaultValue(swigCPtr, index);
    return ret;
  }

  public void setGlobalParameterDefaultValue(int index, double defaultValue) {
    OpenMMSwigPINVOKE.CustomTorsionForce_setGlobalParameterDefaultValue(swigCPtr, index, defaultValue);
  }

  public void addEnergyParameterDerivative(string name) {
    OpenMMSwigPINVOKE.CustomTorsionForce_addEnergyParameterDerivative(swigCPtr, name);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public string getEnergyParameterDerivativeName(int index) {
    string ret = OpenMMSwigPINVOKE.CustomTorsionForce_getEnergyParameterDerivativeName(swigCPtr, index);
    return ret;
  }

  public int addTorsion(int particle1, int particle2, int particle3, int particle4, SWIGTYPE_p_std__vectorT_double_t parameters) {
    int ret = OpenMMSwigPINVOKE.CustomTorsionForce_addTorsion__SWIG_0(swigCPtr, particle1, particle2, particle3, particle4, SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public int addTorsion(int particle1, int particle2, int particle3, int particle4) {
    int ret = OpenMMSwigPINVOKE.CustomTorsionForce_addTorsion__SWIG_1(swigCPtr, particle1, particle2, particle3, particle4);
    return ret;
  }

  public void getTorsionParameters(int index, SWIGTYPE_p_int particle1, SWIGTYPE_p_int particle2, SWIGTYPE_p_int particle3, SWIGTYPE_p_int particle4, SWIGTYPE_p_std__vectorT_double_t parameters) {
    OpenMMSwigPINVOKE.CustomTorsionForce_getTorsionParameters(swigCPtr, index, SWIGTYPE_p_int.getCPtr(particle1), SWIGTYPE_p_int.getCPtr(particle2), SWIGTYPE_p_int.getCPtr(particle3), SWIGTYPE_p_int.getCPtr(particle4), SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setTorsionParameters(int index, int particle1, int particle2, int particle3, int particle4, SWIGTYPE_p_std__vectorT_double_t parameters) {
    OpenMMSwigPINVOKE.CustomTorsionForce_setTorsionParameters__SWIG_0(swigCPtr, index, particle1, particle2, particle3, particle4, SWIGTYPE_p_std__vectorT_double_t.getCPtr(parameters));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setTorsionParameters(int index, int particle1, int particle2, int particle3, int particle4) {
    OpenMMSwigPINVOKE.CustomTorsionForce_setTorsionParameters__SWIG_1(swigCPtr, index, particle1, particle2, particle3, particle4);
  }

  public void updateParametersInContext(Context context) {
    OpenMMSwigPINVOKE.CustomTorsionForce_updateParametersInContext(swigCPtr, Context.getCPtr(context));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void setUsesPeriodicBoundaryConditions(bool periodic) {
    OpenMMSwigPINVOKE.CustomTorsionForce_setUsesPeriodicBoundaryConditions(swigCPtr, periodic);
  }

  public override bool usesPeriodicBoundaryConditions() {
    bool ret = OpenMMSwigPINVOKE.CustomTorsionForce_usesPeriodicBoundaryConditions(swigCPtr);
    return ret;
  }

}

}
